xref: /openbmc/linux/scripts/link-vmlinux.sh (revision cbabf03c)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37is_enabled() {
38	grep -q "^$1=y" include/config/auto.conf
39}
40
41# Nice output in kbuild format
42# Will be supressed by "make -s"
43info()
44{
45	printf "  %-7s %s\n" "${1}" "${2}"
46}
47
48# Generate a linker script to ensure correct ordering of initcalls.
49gen_initcalls()
50{
51	info GEN .tmp_initcalls.lds
52
53	${PYTHON3} ${srctree}/scripts/jobserver-exec		\
54	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
55		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
56		> .tmp_initcalls.lds
57}
58
59# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
60# .tmp_symversions.lds
61gen_symversions()
62{
63	info GEN .tmp_symversions.lds
64	rm -f .tmp_symversions.lds
65
66	for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
67		if [ -f ${o}.symversions ]; then
68			cat ${o}.symversions >> .tmp_symversions.lds
69		fi
70	done
71}
72
73# Link of vmlinux.o used for section mismatch analysis
74# ${1} output file
75modpost_link()
76{
77	local objects
78	local lds=""
79
80	objects="--whole-archive				\
81		${KBUILD_VMLINUX_OBJS}				\
82		--no-whole-archive				\
83		--start-group					\
84		${KBUILD_VMLINUX_LIBS}				\
85		--end-group"
86
87	if is_enabled CONFIG_LTO_CLANG; then
88		gen_initcalls
89		lds="-T .tmp_initcalls.lds"
90
91		if is_enabled CONFIG_MODVERSIONS; then
92			gen_symversions
93			lds="${lds} -T .tmp_symversions.lds"
94		fi
95
96		# This might take a while, so indicate that we're doing
97		# an LTO link
98		info LTO ${1}
99	else
100		info LD ${1}
101	fi
102
103	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
104}
105
106objtool_link()
107{
108	local objtoolcmd;
109	local objtoolopt;
110
111	if is_enabled CONFIG_STACK_VALIDATION && \
112	   ( is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT ); then
113
114		# Don't perform vmlinux validation unless explicitly requested,
115		# but run objtool on vmlinux.o now that we have an object file.
116		if is_enabled CONFIG_UNWINDER_ORC; then
117			objtoolcmd="orc generate"
118		fi
119
120		objtoolopt="${objtoolopt} --lto"
121
122		if is_enabled CONFIG_X86_KERNEL_IBT; then
123			objtoolopt="${objtoolopt} --ibt"
124		fi
125
126		if is_enabled CONFIG_FTRACE_MCOUNT_USE_OBJTOOL; then
127			objtoolopt="${objtoolopt} --mcount"
128		fi
129	fi
130
131	if is_enabled CONFIG_VMLINUX_VALIDATION; then
132		objtoolopt="${objtoolopt} --noinstr"
133	fi
134
135	if [ -n "${objtoolopt}" ]; then
136		if [ -z "${objtoolcmd}" ]; then
137			objtoolcmd="check"
138		fi
139		objtoolopt="${objtoolopt} --vmlinux"
140		if ! is_enabled CONFIG_FRAME_POINTER; then
141			objtoolopt="${objtoolopt} --no-fp"
142		fi
143		if is_enabled CONFIG_GCOV_KERNEL || is_enabled CONFIG_LTO_CLANG; then
144			objtoolopt="${objtoolopt} --no-unreachable"
145		fi
146		if is_enabled CONFIG_RETPOLINE; then
147			objtoolopt="${objtoolopt} --retpoline"
148		fi
149		if is_enabled CONFIG_X86_SMAP; then
150			objtoolopt="${objtoolopt} --uaccess"
151		fi
152		if is_enabled CONFIG_SLS; then
153			objtoolopt="${objtoolopt} --sls"
154		fi
155		info OBJTOOL ${1}
156		tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
157	fi
158}
159
160# Link of vmlinux
161# ${1} - output file
162# ${2}, ${3}, ... - optional extra .o files
163vmlinux_link()
164{
165	local output=${1}
166	local objs
167	local libs
168	local ld
169	local ldflags
170	local ldlibs
171
172	info LD ${output}
173
174	# skip output file argument
175	shift
176
177	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
178		# Use vmlinux.o instead of performing the slow LTO link again.
179		objs=vmlinux.o
180		libs=
181	else
182		objs="${KBUILD_VMLINUX_OBJS}"
183		libs="${KBUILD_VMLINUX_LIBS}"
184	fi
185
186	if [ "${SRCARCH}" = "um" ]; then
187		wl=-Wl,
188		ld="${CC}"
189		ldflags="${CFLAGS_vmlinux}"
190		ldlibs="-lutil -lrt -lpthread"
191	else
192		wl=
193		ld="${LD}"
194		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
195		ldlibs=
196	fi
197
198	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
199
200	# The kallsyms linking does not need debug symbols included.
201	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
202		ldflags="${ldflags} ${wl}--strip-debug"
203	fi
204
205	if is_enabled CONFIG_VMLINUX_MAP; then
206		ldflags="${ldflags} ${wl}-Map=${output}.map"
207	fi
208
209	${ld} ${ldflags} -o ${output}					\
210		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
211		${wl}--start-group ${libs} ${wl}--end-group		\
212		$@ ${ldlibs}
213}
214
215# generate .BTF typeinfo from DWARF debuginfo
216# ${1} - vmlinux image
217# ${2} - file to dump raw BTF data into
218gen_btf()
219{
220	local pahole_ver
221
222	if ! [ -x "$(command -v ${PAHOLE})" ]; then
223		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
224		return 1
225	fi
226
227	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
228	if [ "${pahole_ver}" -lt "116" ]; then
229		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
230		return 1
231	fi
232
233	vmlinux_link ${1}
234
235	info "BTF" ${2}
236	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
237
238	# Create ${2} which contains just .BTF section but no symbols. Add
239	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
240	# deletes all symbols including __start_BTF and __stop_BTF, which will
241	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
242	# objcopy warnings: "empty loadable segment detected at ..."
243	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
244		--strip-all ${1} ${2} 2>/dev/null
245	# Change e_type to ET_REL so that it can be used to link final vmlinux.
246	# Unlike GNU ld, lld does not allow an ET_EXEC input.
247	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
248}
249
250# Create ${2} .S file with all symbols from the ${1} object file
251kallsyms()
252{
253	local kallsymopt;
254
255	if is_enabled CONFIG_KALLSYMS_ALL; then
256		kallsymopt="${kallsymopt} --all-symbols"
257	fi
258
259	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
260		kallsymopt="${kallsymopt} --absolute-percpu"
261	fi
262
263	if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
264		kallsymopt="${kallsymopt} --base-relative"
265	fi
266
267	info KSYMS ${2}
268	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
269}
270
271# Perform one step in kallsyms generation, including temporary linking of
272# vmlinux.
273kallsyms_step()
274{
275	kallsymso_prev=${kallsymso}
276	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
277	kallsymso=${kallsyms_vmlinux}.o
278	kallsyms_S=${kallsyms_vmlinux}.S
279
280	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
281	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
282
283	info AS ${kallsyms_S}
284	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
285	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
286	      -c -o ${kallsymso} ${kallsyms_S}
287}
288
289# Create map file with all symbols from ${1}
290# See mksymap for additional details
291mksysmap()
292{
293	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
294}
295
296sorttable()
297{
298	${objtree}/scripts/sorttable ${1}
299}
300
301# Delete output files in case of error
302cleanup()
303{
304	rm -f .btf.*
305	rm -f .tmp_System.map
306	rm -f .tmp_initcalls.lds
307	rm -f .tmp_symversions.lds
308	rm -f .tmp_vmlinux*
309	rm -f System.map
310	rm -f vmlinux
311	rm -f vmlinux.map
312	rm -f vmlinux.o
313	rm -f .vmlinux.d
314}
315
316# Use "make V=1" to debug this script
317case "${KBUILD_VERBOSE}" in
318*1*)
319	set -x
320	;;
321esac
322
323if [ "$1" = "clean" ]; then
324	cleanup
325	exit 0
326fi
327
328# Update version
329info GEN .version
330if [ -r .version ]; then
331	VERSION=$(expr 0$(cat .version) + 1)
332	echo $VERSION > .version
333else
334	rm -f .version
335	echo 1 > .version
336fi;
337
338# final build of init/
339${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
340
341#link vmlinux.o
342modpost_link vmlinux.o
343objtool_link vmlinux.o
344
345# modpost vmlinux.o to check for section mismatches
346${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
347
348info MODINFO modules.builtin.modinfo
349${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
350info GEN modules.builtin
351# The second line aids cases where multiple modules share the same object.
352tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
353	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
354
355btf_vmlinux_bin_o=""
356if is_enabled CONFIG_DEBUG_INFO_BTF; then
357	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
358	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
359		echo >&2 "Failed to generate BTF for vmlinux"
360		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
361		exit 1
362	fi
363fi
364
365kallsymso=""
366kallsymso_prev=""
367kallsyms_vmlinux=""
368if is_enabled CONFIG_KALLSYMS; then
369
370	# kallsyms support
371	# Generate section listing all symbols and add it into vmlinux
372	# It's a three step process:
373	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
374	#     but __kallsyms is empty.
375	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
376	#     the right size
377	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
378	#     the right size, but due to the added section, some
379	#     addresses have shifted.
380	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
381	# 3)  That link may have expanded the kernel image enough that
382	#     more linker branch stubs / trampolines had to be added, which
383	#     introduces new names, which further expands kallsyms. Do another
384	#     pass if that is the case. In theory it's possible this results
385	#     in even more stubs, but unlikely.
386	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
387	#     other bugs.
388	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
389	#
390	# a)  Verify that the System.map from vmlinux matches the map from
391	#     ${kallsymso}.
392
393	kallsyms_step 1
394	kallsyms_step 2
395
396	# step 3
397	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
398	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
399
400	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
401		kallsyms_step 3
402	fi
403fi
404
405vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
406
407# fill in BTF IDs
408if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
409	info BTFIDS vmlinux
410	${RESOLVE_BTFIDS} vmlinux
411fi
412
413info SYSMAP System.map
414mksysmap vmlinux System.map
415
416if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
417	info SORTTAB vmlinux
418	if ! sorttable vmlinux; then
419		echo >&2 Failed to sort kernel tables
420		exit 1
421	fi
422fi
423
424# step a (see comment above)
425if is_enabled CONFIG_KALLSYMS; then
426	mksysmap ${kallsyms_vmlinux} .tmp_System.map
427
428	if ! cmp -s System.map .tmp_System.map; then
429		echo >&2 Inconsistent kallsyms data
430		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
431		exit 1
432	fi
433fi
434
435# For fixdep
436echo "vmlinux: $0" > .vmlinux.d
437